#!/usr/bin/env python
'''
Sets all port speed to 10G
'''
import sys
import errno, sys
import colorsys
sys.path.append('/usr/lib/python2.7/dist-packages/python_sdk_api/')
sys.path.append('/usr/lib/python2.7/site-packages/python_sdk_api/')
sys.path.append('/usr/local/lib/python2.7/dist-packages/python_sdk_api/')
sys.path.append('/usr/local/lib/python2.7/site-packages/python_sdk_api/')

from sx_api import *
from test_infra_common import *

print "[+] opening sdk"
rc, handle = sx_api_open(None)
print ("sx_api_open handle:0x%x , rc %d " % ( handle, rc) )
if (rc != SX_STATUS_SUCCESS):
    print "Failed to open api handle.\nPlease check that SDK is running."
    sys.exit(errno.EACCES)

port_attributes_list = new_sx_port_attributes_t_arr(64)
port_cnt_p = new_uint32_t_p()
oper_mtu_size_p=new_sx_port_mtu_t_p()
uint32_t_p_assign(port_cnt_p,64)
admin_speed_p = new_sx_port_speed_capability_t_p()
#oper_state_p = new_sx_port_oper_state_t_p()
#admin_state_p = new_sx_port_admin_state_t_p()
#module_state_p = new_sx_port_module_state_t_p()

rc = sx_api_port_device_get(handle, 1 , 0, port_attributes_list,  port_cnt_p)
if rc != SX_STATUS_SUCCESS:
    print ("sx_api_port_device_get failed, rc=%d] " % ( rc) )
    sys.exit(errno.EACCES)
port_cnt = uint32_t_p_value(port_cnt_p)
for i in range(0,port_cnt):

    port_attributes = sx_port_attributes_t_arr_getitem(port_attributes_list,i)
    is_vport = check_vport(int(port_attributes.log_port))
    is_nve = check_nve(int(port_attributes.log_port))
    if is_nve or is_vport:
        continue
    sx_api_port_state_set(handle, int(port_attributes.log_port), SX_PORT_ADMIN_STATUS_DOWN)
    if rc != SX_STATUS_SUCCESS:
        print ("sx_api_port_state_set failed, rc=%d] " % ( rc) )
        sys.exit(errno.EACCES)
	
    print ("[+] Setting log_port:0x%x admin state to DOWN." % (port_attributes.log_port))
    admin_speed_p = new_sx_port_speed_capability_t_p()
    admin_speed_p.mode_25GB_CR=1
    admin_speed_p.mode_25GB_SR=1
    sx_api_port_speed_admin_set(handle, int(port_attributes.log_port), admin_speed_p)
    if rc != SX_STATUS_SUCCESS:
        print ("sx_api_port_speed_admin_set failed, rc=%d] " % ( rc) )
        sys.exit(errno.EACCES)
    print ("[+] Setting log_port:0x%x speed to 25G." % (port_attributes.log_port))

    sx_api_port_state_set(handle, int(port_attributes.log_port), SX_PORT_ADMIN_STATUS_UP)
    if rc != SX_STATUS_SUCCESS:
        print ("sx_api_port_state_set failed, rc=%d] " % ( rc) )
        sys.exit(errno.EACCES)
    print ("[+] Setting log_port:0x%x admin state to UP." % (port_attributes.log_port))

""" ############################################################################################ """
sx_api_close(handle)
""" ############################################################################################ """
