#!/usr/bin/env python
'''
This file contains Python command example for the ALL PORT COUNTER READ module.
Python commands syntax is very similar to the Switch SDK APIs. 
You can learn more about each command and its parameters by reading the SwitchX API Reference Manual.

The example below demonstrates the configuration of different port attributes.
'''
import sys
import os.path
sys.path.append('/usr/lib/python2.7/dist-packages/python_sdk_api/')
sys.path.append('/usr/lib/python2.7/site-packages/python_sdk_api/')
sys.path.append('/usr/local/lib/python2.7/dist-packages/python_sdk_api/')
sys.path.append('/usr/local/lib/python2.7/site-packages/python_sdk_api/')
from sx_api import *
            
print "[+] opening sdk"
rc, handle = sx_api_open(None)
print ("sx_api_open handle:0x%x , rc %d " % ( handle, rc) )
if (rc != 0):
    print "Failed to open api handle.\nPlease check that SDK is running."
    exit()
    
if len(sys.argv) >= 2:
    cmd_str = str(sys.argv[1])
    if cmd_str == 'SX_ACCESS_CMD_ENABLE':
        cmd = SX_ACCESS_CMD_ENABLE
    elif cmd_str == 'SX_ACCESS_CMD_DISABLE':
        cmd = SX_ACCESS_CMD_DISABLE
    else:
        cmd = SX_ACCESS_CMD_ADD
        print "CMD not supported!"+cmd_str
    
    print ("cmd is - %s." % cmd )
else:
    cmd = SX_ACCESS_CMD_ENABLE
    print ("No parameter.\nWill use the default: %s ." % cmd )

rc = sx_api_transaction_mode_set(handle, cmd)

print ("sx_api_transaction_mode_set, rc %d" % rc )

sx_api_close(handle)
